Subject: Re: bi_recs

From: Benjamin Herrenschmidt <[email-masked]>
Date: Sat, 02 Oct 2004 14:35:32 +1000

> 
> ppc64 head.S and startup looks quite fun. After jumping through a few
> hoops you eventually end up in prom_init and start setting up the OF
> device-tree (btw it looks like at least one call to prom_panic doesn't
> relocate the string it wants to print to real memory - is this what
> the comments are referring to out of sheer interest?). I am assuming
> that you always expect to see an Open Firmware on ppc64 and simply use
> bi_recs to pass accross additional information from the bootloader,
> but I've only had a cursory look on the train on the way home from
> work this evening so please be gentle.
> 
> I'll give this a go through over the weekend and figure out how to get
> this hooked in to the ppc32 tree.

bi_recs have been removed completely from ppc64. head.S explains
how the entry is done. You can enter the kernel with r5=NULL if
you provide the flattened device-tree in r3. prom_init does just
that in fact (re-enters the kernel with that setup).

Ben.